SystemOrganization addCategory: #NickAlexanderBuilder!

Object subclass: #ConfigurationOfNickAlexander
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'NickAlexanderBuilder'!

!ConfigurationOfNickAlexander class methodsFor: 'development support' stamp: 'NickAlexander 1/2/2012 20:27'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfNickAlexander class methodsFor: 'private' stamp: 'NickAlexander 1/2/2012 20:27'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfNickAlexander class methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:27'!
buildCogVMImage
	CogVMImageBuilder new buildImage.! !

!ConfigurationOfNickAlexander class methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:27'!
buildDBXTalklmage
	DBXTalkImageBuilder new buildImage.! !

!ConfigurationOfNickAlexander class methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:49'!
buildFFIImage
	FFIImageBuilder new buildImage.! !

!ConfigurationOfNickAlexander class methodsFor: 'private' stamp: 'NickAlexander 1/2/2012 20:27'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfNickAlexander class methodsFor: 'private' stamp: 'NickAlexander 1/2/2012 20:27'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfNickAlexander class methodsFor: 'metacello tool support' stamp: 'NickAlexander 1/2/2012 20:27'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfNickAlexander class methodsFor: 'loading' stamp: 'NickAlexander 1/2/2012 20:27'!
loadCogVM
	CogVMImageBuilder new loadPackages: 'CogVM'! !

!ConfigurationOfNickAlexander class methodsFor: 'loading' stamp: 'NickAlexander 1/2/2012 20:27'!
loadDBXTalk
	DBXTalkImageBuilder new loadPackages: 'DBXTalk'.! !

!ConfigurationOfNickAlexander class methodsFor: 'accessing' stamp: 'NickAlexander 1/2/2012 20:27'!
project

	^self new project! !

!ConfigurationOfNickAlexander class methodsFor: 'development support' stamp: 'NickAlexander 1/2/2012 20:27'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfNickAlexander methodsFor: 'baselines' stamp: 'NickAlexander 1/2/2012 20:43'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		
		spec blessing: #baseline.

  " =========================================
The following the list of projects that I DO DEVELOPE. Hence, I always want the bleedingEdge, and most of the times, I want to build an image for them. 
 ========================================="
			
		spec
			project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				loads: #('default' );
				file: 'ConfigurationOfFFI';
				versionString: #bleedingEdge;
				repository: 'http://source.squeak.org/FFI' ].
		
		
  " =========================================
The following the list of projects that I usually load and play or develop a little bit. But since they are not my projects, I usually use the latest available metacello version and not the bleedingEdge.. 
 ========================================="
		
		spec
			project: 'CogVM' with: [
			spec
				className: 'ConfigurationOfCog';
				loads: #('default' );
				file: 'ConfigurationOfCog';
				versionString: '3.6';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
					
		spec
			project: 'TextLint' with: [
			spec
				className: 'ConfigurationOfTextLint';
				loads: #('default' );
				file: 'ConfigurationOfTextLint';
				repository: 'http://www.squeaksource.com/textlint' ].


  " =========================================
The following the list of TOOLS, ADDONS  that I use for my own images. Since they are not my projects, I usually use the latest available metacello version and not the bleedingEdge.
In addition, not all tools and addons are loaded in all type of images I build. Each image decides what to include.
 ========================================="

					
		spec
			project: 'SandcastlesThemes' with: [
			spec
				className: 'ConfigurationOfSandcastleThemes';
				loads: #('default');
				file: 'ConfigurationOfSandcastleThemes';
				repository: 'http://www.squeaksource.com/SandcastlesThemes' ].
		
		spec
			project: 'TilingWindowManager' with: [
			spec
				className: 'ConfigurationOfTilingWindowManager';
				loads: #('default');
				file: 'ConfigurationOfTilingWindowManager';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/TilingWindowManager' ].
		
		spec
			project: 'GlamourCore' with: [
			spec
				className: 'ConfigurationOfGlamour';
				loads: #('Core' 'Morphic' );
				file: 'ConfigurationOfGlamour';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/Glamour' ].
	
"		spec
			project: 'Glamoroust' with: [
			spec
				className: 'ConfigurationOfGlamoroust';
				loads: #('GT-Inspector' 'GT-Playground' );
				file: 'ConfigurationOfGlamoroust';
				repository: 'http://www.squeaksource.com/glamoroust' ].
		"
		
		spec project: 'Keymapping' with: [
			spec
				className: 'ConfigurationOfKeymapping';
				loads: #('forDeveloper' );
				file: 'ConfigurationOfKeymapping';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/ShortWays' ].
		
		
		spec 
			package: 'CodeStats' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'];
			package: 'SimpleLogger' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'];
			package: 'GT-Inspector' with: [
				spec repository: 'http://www.squeaksource.com/glamoroust';
				requires: #('GlamourCore').
				].
		
  " =========================================
The following is a list of groups for building my own images. Notice that for each image group there should be a class side method #buildXXXImage
 ========================================="
			
	
			
		spec
			group: 'DBXTalkImage' with: #( 'BaseImage' 'DBXTalk');
			group: 'CogVMImage' with: #( 'BaseImage' 'CogVM');

			group: 'FFIImage' with: #( 'BaseImage' 'FFI');
			
			group: 'BaseImage' with: #("'TilingWindowManager'" 'SimpleLogger' 'CodeStats' "'GT-Inspector'" "'Keymapping'").

		 ].
	! !

!ConfigurationOfNickAlexander methodsFor: 'accessing' stamp: 'NickAlexander 1/2/2012 20:27'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: 'BuildOffline'
	poolDictionaries: ''
	category: 'NickAlexanderBuilder'!

GeneralImageBuilder subclass: #CogVMImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NickAlexanderBuilder'!

!CogVMImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
baseImageName
	^ 'CogVMGenerator'! !

!CogVMImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 12/20/2011 22:40'!
customPreferences
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/Pharo/VM/git/cogVMBlessedSSH/blessed/image/cogVMWallpaper.jpg'.
	Debugger logFileName: 'CogVMDebug.log'.
	! !

!CogVMImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
imageDirectory
	"This directory is not by chance. This is the special place where I have the downloaded platform code from git. Hence, I can then easily build the VM"
	^ '/Users/mariano/Pharo/VM/git/cogVMMaster/blessed/image/'! !

!CogVMImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'CogVMImage'.	
! !

!CogVMImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/24/2011 17:46'!
lastActions
	super lastActions.
	^ self openHelpWorkspace ! !

!CogVMImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/VMMaker'! !

GeneralImageBuilder subclass: #DBXTalkImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NickAlexanderBuilder'!

!DBXTalkImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:37'!
baseImageName
	^ 'DBXTalk'! !

!DBXTalkImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 10/16/2011 23:17'!
customPreferences
	LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: '/Users/mariano/DBXTalk/logo/DBXTALK 4-6_small.png')).
	PolymorphSystemSettings desktopColor: (Color r: 0.7030000000000001 g: 0.6930000000000001 b: 0.6930000000000001).
	Debugger logFileName: 'DBXTalkDebug.log'.
	
! !

!DBXTalkImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:38'!
imageDirectory
	^ '/Users/mariano/DBXTalk/imagenes/'! !

!DBXTalkImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'DBXTalkImage'.	
! !

!DBXTalkImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/DBXTalk'! !

GeneralImageBuilder subclass: #FFIImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NickAlexanderBuilder'!

!FFIImageBuilder methodsFor: 'saving' stamp: 'NickAlexander 1/2/2012 20:44'!
baseImageName
	^ 'FFI'! !

!FFIImageBuilder methodsFor: 'preferences' stamp: 'NickAlexander 1/2/2012 20:44'!
customPreferences
	super customPreferences.! !

!FFIImageBuilder methodsFor: 'saving' stamp: 'NickAlexander 1/2/2012 20:45'!
imageDirectory
	^ '/Users/ncalexan/Pharo/images/FFI/'! !

!FFIImageBuilder methodsFor: 'loading' stamp: 'NickAlexander 1/2/2012 20:45'!
imageGroupNameToLoad
	^ 'FFIImage'! !

!FFIImageBuilder methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:45'!
lastActions
	super lastActions.
! !

!FFIImageBuilder methodsFor: 'repositories' stamp: 'NickAlexander 1/2/2012 20:46'!
repositoryName 
	^ 'http://source.squeak.org/FFI'! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:36'!
buildOffline
	BuildOffline ifNil: [ BuildOffline := false ].
	^ BuildOffline! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:37'!
buildOffline: aBoolean
	BuildOffline := aBoolean! !

!GeneralImageBuilder class methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:58'!
configurationClass
	^ ConfigurationOfNickAlexander! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'NickAlexander 1/2/2012 20:35'!
baseImageName
	self subclassResponsibility! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/30/2011 16:12'!
buildImage
	self loadImagePackages.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self lastActions.
	self saveImage.! !

!GeneralImageBuilder methodsFor: 'cleaning' stamp: 'NickAlexander 1/2/2012 20:47'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].

	"Clear Monticello Caches"
	MCFileBasedRepository flushAllCaches.
	MCMethodDefinition shutDown.
	MCDefinition clearInstances.

	"Cleanup Smalltalk"
	Smalltalk flushClassNameCache.
	Smalltalk organization removeEmptyCategories.
	Smalltalk allClassesAndTraitsDo: [ :each |
		each organization removeEmptyCategories; sortCategories.
		each class organization removeEmptyCategories; sortCategories ].
	
	"Cleanup System Memory"
	Smalltalk garbageCollect.
	Symbol compactSymbolTable.
	
	ScriptLoader new cleanUpForRelease.	

	"put back the author"
	Author fullName: 'NickAlexander'.
	! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'NickAlexander 1/2/2012 20:34'!
customPreferences
	Debugger logFileName: self baseImageName, 'Debug.log'.
	! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'NickAlexander 1/2/2012 20:57'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.
	Parser warningAllowed: false. 
	TasklistMorph keepOpen: true.
	"(Smalltalk at: #TWMBar) showTWMBar: true."
	"Smalltalk tools register: (Smalltalk at: #GTInspector)  as: #objectExplorer."
	" GTPlayground is not yet working correctly, so I disable it for the moment"
	"Smalltalk tools register: (Smalltalk at: #GTPlayground)  as: #workspace."
! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:47'!
generalPreLoad
	MCCacheRepository default directory: self sharedPackageCacheDirectory.
	MCDirectoryRepository defaultDirectoryName: self sharedPackageCacheName.
	Author fullName: 'NickAlexander'.
	
! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'NickAlexander 1/2/2012 20:58'!
lastActions
	self putMyRepositoriesAtTheEnd.
	"self setSqueakSourceUsernameAndPassword."! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
loadImagePackages
	self loadPackages: self imageGroupNameToLoad.! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'NickAlexander 1/2/2012 20:28'!
loadPackages: packagesOrGroups
	| version repo |
	self generalPreLoad.
	version := (self class configurationClass project version: #bleedingEdge).
	self class buildOffline 
		ifTrue: [ 
			repo := MCDirectoryRepository new.
  			repo directory: self sharedPackageCacheDirectory.
 	 		version repositoryOverrides: (OrderedCollection with: repo).
			 ].
	version load: packagesOrGroups.
	 ! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/1/2011 20:01'!
putMyRepositoriesAtTheEnd
	| myRepo |
	myRepo :=  MCRepositoryGroup default repositories 
		detect: [:each | each description = self repositoryName]
		ifNone: [ "this means it was loaded offline used the shared package cache, so I do nothing" ^ self ].
	MCRepositoryGroup default  removeRepository: myRepo.
	MCRepositoryGroup default  addRepository: myRepo.
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'NickAlexander 1/2/2012 20:46'!
repositoriesPassword
	^ (FileDirectory default oldFileNamed: '/Users/ncalexan/Pharo/repositoriesPassword.txt') contents
! !

!GeneralImageBuilder methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 16:47'!
repositoryName
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:09'!
saveImage

	Smalltalk saveAs: self baseImageName inDirectoryNamed: self imageDirectory
! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/24/2011 18:00'!
setSqueakSourceUsernameAndPassword
	"This sets the username and password in all squeaksource repositories. The password must stored in a specific file in the machine where you are building this image."
	(MCRepositoryGroup default  repositories 
		select: [:each | (each isKindOf: MCHttpRepository) 
			and: [each locationWithTrailingSlash includesSubString: 'www.squeaksource.com'] ]) do: [:each |
			each 
				user: 'MMP';
				password: self repositoriesPassword.
			]! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/21/2011 14:11'!
sharedPackageCacheDirectory.
	^ (FileDirectory on: self sharedPackageCacheName)
		assureExistence;
		yourself! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'NickAlexander 1/2/2012 20:46'!
sharedPackageCacheName
	^ '/Users/ncalexan/Pharo/localRepo/'! !
